/* SofChat (Web Chat program SHM version)      */
/* Copyright(c) 1996-1997 Y.YONEYAMA           */
/*                                             */
/* messages.j : JIS code                       */

#include <stdio.h>
#include "utils.h"
#include "messages.h"

#ifndef DEFAULT_LANG
#define DEFAULT_LANG MSG_JA
/*#define DEFAULT_LANG MSG_EN*/
#endif

char *messages[][2] = {
  {"$@%=%U$A$c$C$H(B",
   "SofChat"},
  {"SofChat",
   "SofChat"},
  {"$@8=:_$N;22C<T(B",
   "Members"},
  {"$@8=:_$NOCBj(B",
   "Topic"},
  {"$@L>A0$rF~NO$7$F(B[$@F~<<(B]$@$G;22C$G$-$^$9(B",
   "Please input your name and push 'Join'."},
  {"$@L>A0(B",
   "Name"},
  {"$@%"%I%l%9(B",
   "Address"},
  {"$@H/8@(B",
   "Send"},
  {"$@%/%j%"(B",
   "Clear"},
  {"$@F~<<(B",
   "Join"},
  {"$@B`<<(B",
   "Leave"},
  {"$@%j%m!<%I(B",
   "Reload"},
  {"$@%j%s%/(B",
   "Links"},
  {"$@=i4|2=$5$l$^$7$?!#(B",
   "Initialized."},
  {"$@$*Hh$lMM$G$7$?!#$^$?$N$4MxMQ$r$*BT$A$7$F$*$j$^$9!#(B",
   "Good bye!"},
  {"$@F~<<;~9o(B",
   "Login :"},
  {"$@B`<<;~9o(B",
   "Logout:"},
  {"$@8=:_$4MxMQ$K$J$l$^$;$s(B",
   "Cannot access..."},
  {"$@%Q%9%o!<%I$,0c$$$^$9(B",
   "Invalid password."},
  {"$@%a%C%;!<%8$,Aw?.$G$-$^$;$s$G$7$?(B",
   "Cannnot send the mesage."},
  {"$@%3%^%s%I$N<B9T$K<:GT$7$^$7$?(B",
   "Command failed."},
  {"$@%U%l!<%`BP1~$N%V%i%&%6$r$4;HMQ$/$@$5$$!%!%!%(B",
   "You should use the frame support browser."},
  {"$@7G<(HD(B",
   "bulletin board"},
  {"$@=q$-9~$`(B",
   "Send"},
  {"$@%?%$%H%k(B",
   "Title"},
  {"$@GX7J?'(B",
   "Background"},
  {"$@J8;z?'(B",
   "Text"},
  {"$@L>A0$N?'(B",
   "Name"},
  {"$@;~4V$N?'(B",
   "Date"},
  {"$@%j%s%/$N?'(B",
   "Link"},
  {"$@JQ99(B",
   "Modify"},
  {"$@85$KLa$9(B",
   "Undo"},
  {"$@=i4|2=(B",
   "Initialize"},
  {"$@L$FI(B",
   "New Messages"},
  {"$@:o=|(B",
   "Cancel"},
  {"$@%*!<%H%/%j%"(B",
   "Auto clear"},
  {"$@:FJT=8(B",
   "Undo"},
  {"$@%U%!%$%k(B[%s]$@$K=q$-9~$_$,$G$-$^$;$s!#(B",
   "Can't write to file '%s'."},
  {"$@%7!<%/%l%C%H(B",
   "Secure"}
};

char *schatinfo[2] = {
  "<H3>$@$3$N%A%c%C%H$NFCD'(B</H3>\n"
  "<UL>\n"
  "<LI>$@%m!<%^;z2>L>JQ495!G=(B\n"
  "<LI>$@7G<(HD$,;HMQ$G$-$^$9(B\n"
  "<LI>ROM$@5!G=$,$"$j$^$;$s(B\n"
  "<LI>$@%?%0$,;HMQ$G$-$^$9(B($@JD$8K:$lJd@55!G=IU$-(B)\n"
  "<LI>2$@J,0J>e%j%m!<%I$,;_$^$k$H<+F0E*$K=|L>$5$l$^$9(B\n"
  "<LI>10$@J,0J>e=q$-9~$_$,$J$$$HL>A0$K(B(Zzz)$@$,IU$-$^$9(B\n"
  "<LI><font size=2>$@;~!9%P%0$k!)(B(^^;;;</font>\n"
  "</UL>\n"
  "($@%"%I%l%9$K$O!"(BURL$@$b5-=R$G$-$^$9(B)\n"
,
  "<H3>This chat has following features</H3>\n"
  "<UL>\n"
  "<LI>Supports a romaji-kana conversion\n"
  "<LI>Supports a bulletin board\n"
  "<LI>ROM forbidden\n"
  "<LI>Tags available(last brackets are complemented automatically)\n"
  "<LI>Members are expelled when a chat page isn't reloaded in two or more minutes\n"
  "<LI>(Zzz) is added to the name who doesn't write in ten or more minutes\n"
  "<LI><font size=2>Bugs occur sometimes</FONT>"
  "</UL>\n"
  "(An address field can contains URL)\n"
};

LINK def_links[] = {
 {
  "$@%=%U8&(B Home Page",
  "SOFKEN Home Page",
  "http://yindy1.aist-nara.ac.jp/~tetu-s/sofken96/index-j.html"
 },
 {
  "$@%=%U$A$c$C$H(B Official Web Page",
  "SofChat Official Web Page",
  "http://www.asahi-net.or.jp/~fj9y-ynym/sofchat/index.html"
 }
};


int LANG = DEFAULT_LANG;
int CONV = 0;

typedef struct {
  char *roma;
  char *kana;
} RK;

static RK _rk_table[] = {
  {" ",  " "},
  {"a",  "$@$"(B"},
  {"ba", "$@$P(B"},
  {"bi", "$@$S(B"},
  {"bu", "$@$V(B"},
  {"be", "$@$Y(B"},
  {"bo", "$@$\(B"},
  {"bya", "$@$S$c(B"},
  {"byu", "$@$S$e(B"},
  {"byo", "$@$S$g(B"},
  {"cha", "$@$A$c(B"},
  {"chi", "$@$A(B"},
  {"chu", "$@$A$e(B"},
  {"cho", "$@$A$g(B"},
  {"cya", "$@$A$c(B"},
  {"cyu", "$@$A$e(B"},
  {"che", "$@$A$'(B"},
  {"cye", "$@$A$'(B"},
  {"cyo", "$@$A$g(B"},
  {"da", "$@$@(B"},
  {"di", "$@$B(B"},
  {"de", "$@$G(B"},
  {"do", "$@$I(B"},
  {"du", "$@$E(B"},
  {"dha", "$@$G$c(B"},
  {"dhi", "$@$G$#(B"},
  {"dhu", "$@$G$e(B"},
  {"dhe", "$@$G$'(B"},
  {"dho", "$@$G$g(B"},
  {"e",  "$@$((B"},
  {"fa", "$@$U$!(B"},
  {"fu", "$@$U(B"},
  {"fe", "$@$U$'(B"},
  {"fo", "$@$U$)(B"},
  {"ga", "$@$,(B"},
  {"gi", "$@$.(B"},
  {"gu", "$@$0(B"},
  {"ge", "$@$2(B"},
  {"go", "$@$4(B"},
  {"gya", "$@$.$c(B"},
  {"gyu", "$@$.$e(B"},
  {"gyo", "$@$.$g(B"},
  {"ha", "$@$O(B"},
  {"hi", "$@$R(B"},
  {"hu", "$@$U(B"},
  {"he", "$@$X(B"},
  {"ho", "$@$[(B"},
  {"hya", "$@$R$c(B"},
  {"hyu", "$@$R$e(B"},
  {"hyo", "$@$R$g(B"},
  {"i",  "$@$$(B"},
  {"ja", "$@$8$c(B"},
  {"jya", "$@$8$c(B"},
  {"ji", "$@$8(B"},
  {"jyu", "$@$8$e(B"},
  {"je", "$@$8$'(B"},
  {"jo", "$@$8$g(B"},
  {"ju", "$@$8$e(B"},
  {"jyo", "$@$8$g(B"},
  {"ka", "$@$+(B"},
  {"ki", "$@$-(B"},
  {"ku", "$@$/(B"},
  {"ke", "$@$1(B"},
  {"ko", "$@$3(B"},
  {"kya", "$@$-$c(B"},
  {"kyu", "$@$-$e(B"},
  {"kyo", "$@$-$g(B"},
  {"la", "$@$i(B"},
  {"li", "$@$j(B"},
  {"lu", "$@$k(B"},
  {"le", "$@$l(B"},
  {"lo", "$@$m(B"},
  {"ma", "$@$^(B"},
  {"mi", "$@$_(B"},
  {"mu", "$@$`(B"},
  {"me", "$@$a(B"},
  {"mo", "$@$b(B"},
  {"mya", "$@$_$c(B"},
  {"myu", "$@$_$e(B"},
  {"myo", "$@$_$g(B"},
  {"na", "$@$J(B"},
  {"ni", "$@$K(B"},
  {"nu", "$@$L(B"},
  {"ne", "$@$M(B"},
  {"no", "$@$N(B"},
  {"nya", "$@$K$c(B"},
  {"nyu", "$@$K$e(B"},
  {"nyo", "$@$K$g(B"},
  {"o",  "$@$*(B"},
  {"pa", "$@$Q(B"},
  {"pi", "$@$T(B"},
  {"pu", "$@$W(B"},
  {"pe", "$@$Z(B"},
  {"po", "$@$](B"},
  {"pya", "$@$T$c(B"},
  {"pyu", "$@$T$e(B"},
  {"pyo", "$@$T$g(B"},
  {"qa", "$@$/$!(B"},
  {"qi", "$@$/$#(B"},
  {"qu", "$@$/(B"},
  {"qe", "$@$/$'(B"},
  {"qo", "$@$/$)(B"},
  {"ra", "$@$i(B"},
  {"ri", "$@$j(B"},
  {"ru", "$@$k(B"},
  {"re", "$@$l(B"},
  {"ro", "$@$m(B"},
  {"rya", "$@$j$c(B"},
  {"ryu", "$@$j$e(B"},
  {"ryo", "$@$j$g(B"},
  {"sa", "$@$5(B"},
  {"si", "$@$7(B"},
  {"shi", "$@$7(B"},
  {"shu", "$@$7$e(B"},
  {"su", "$@$9(B"},
  {"se", "$@$;(B"},
  {"so", "$@$=(B"},
  {"sya", "$@$7$c(B"},
  {"syu", "$@$7$e(B"},
  {"syo", "$@$7$g(B"},
  {"sho", "$@$7$g(B"},
  {"ta", "$@$?(B"},
  {"ti", "$@$A(B"},
  {"tu", "$@$D(B"},
  {"tsu", "$@$D(B"},
  {"te", "$@$F(B"},
  {"to", "$@$H(B"},
  {"tya", "$@$A$c(B"},
  {"tyu", "$@$A$e(B"},
  {"tyo", "$@$A$g(B"},
  {"u",  "$@$&(B"},
  {"va",  "$@%t%!(B"},
  {"vi",  "$@%t%#(B"},
  {"vu",  "$@%t(B"},
  {"ve",  "$@%t%'(B"},
  {"vo",  "$@%t%)(B"},
  {"wa", "$@$o(B"},
  {"wi", "$@$&$#(B"},
  {"wu", "$@$%(B"},
  {"we", "$@$&$'(B"},
  {"wo", "$@$r(B"},
  {"xa", "$@$!(B"},
  {"xi", "$@$#(B"},
  {"xu", "$@$%(B"},
  {"xe", "$@$'(B"},
  {"xo", "$@$)(B"},
  {"xtu", "$@$C(B"},
  {"xya", "$@$c(B"},
  {"xyu", "$@$e(B"},
  {"xyo", "$@$g(B"},
  {"xka", "$@%u(B"},
  {"xke", "$@%v(B"},
  {"xwa", "$@$n(B"},
  {"xwi", "$@$p(B"},
  {"xwe", "$@$q(B"},
  {"ya", "$@$d(B"},
  {"yu", "$@$f(B"},
  {"yo", "$@$h(B"},
  {"za", "$@$6(B"},
  {"zi", "$@$8(B"},
  {"zu", "$@$:(B"},
  {"ze", "$@$<(B"},
  {"zo", "$@$>(B"},
  {NULL, NULL}
};

typedef struct {
  char *roma;
  char *kana[3];  /* convstat */
} RK2;

static RK2 _rk_table2[] = {
  {"!",  NULL, "$@!*(B", ""},       /* 0x21 */
  {"'s",  NULL, "$@$:(B", ""},       /* 0x27 */
  {",",  NULL, "$@!"(B", ""},       /* 0x2c */
  {"->", "$@"*(B", NULL, NULL},        /* 0x2d */
  {"-",  NULL, "$@!<(B", ""},
  {"...",  NULL, "$@!&!&!&(B", NULL}, /* 0x2e */
  {".",  NULL, "$@!#(B", NULL},
  {"<-", "$@"+(B", "", ""},        /* 0x3c */
  {"<",  NULL, "$@!c(B", ""},       /* 0x3e */
  {">",  NULL, "$@!d(B", ""},       /* 0x3e */
  {"?",  NULL, "$@!)(B", ""},       /* 0x3f */
  {"[",  "$@!V(B", "", ""},        /* 0x5b */
  {"]",  "$@!W(B", "", ""},       /* 0x5d */
  {"bye", "$@%P%$(B", "", ""},
  {"by", "$@%P%$(B", "", ""},
  {"b", "$@$V(B", "", ""},
  {"cker", NULL, "$@$C$+!<(B", ""},
  {"cur", "$@$+(B", "", ""},
  {"cra", "$@$/$i(B", "", ""},
  {"cau", "$@$3$&(B", "", ""},
  {"can", "$@$-$c$s(B", NULL, NULL},
  {"ca", "$@$+(B", "", ""},
  {"ci", "$@$A(B", "", ""},
  {"co", "$@$3(B", "", ""},
  {"ce", "$@$;(B", "$@$9(B", ""},
  {"ch", "$@$A(B", "", ""},
  {"ck", NULL, "$@$C$/(B", ""},
  {"ct", NULL, "$@$/$H(B", ""},
  {"c", "$@$7!<(B", "$@$/(B", "$@$7!<(B"},
  {"dy", "$@$@$$(B", "$@$G$#(B", ""},
  {"d", "$@$G$#(B", "$@$I(B", ""},
  {"file", "$@$U$!$$$k(B", "", ""},
  {"fi", "$@$U$#(B", "", ""},
  {"ff", NULL, "$@$U(B", ""},
  {"f", "$@$U(B", "", ""},
  {"ght", NULL, "$@$H(B", ""},
  {"g", "$@$8!<(B", "$@$0(B", ""},
  {"http", "$@$($#$A$F$#$F$#$T!<(B", "$@!<(B", ""},
  {"h", "$@$($#$A(B", "$@!<(B", ""},
  {"j", "$@$8$'$#(B", "$@$8(B", ""},
  {"kno", "$@$N(B", NULL, NULL},
  {"k", "$@$1(B", "$@$/(B", ""},
  {"llo", NULL, "$@$m!<(B", ""},
  {"ll", NULL, "$@$k(B", ""},
  {"lp", NULL, "$@$k$W(B", ""},
  {"ly", "$@$j(B", "$@$j$#(B", ""},
  {"l", "$@$($k(B", "$@$k(B", ""},
  {"mpu", "$@$s$T$e(B", "", ""},
  {"ml", "$@$($`$($k(B", "", ""},
  {"my ", "$@$^$$(B", "", ""},
  {"mp", "$@$s$W(B", "", ""},
  {"m", "$@$($`(B", "$@$`(B", ""},
  {"ny", "$@$K(B", "$@$K!<(B", ""},
  {"nn",  "$@$s(B", "", NULL},
  {"n",  "$@$s(B", "", ""},
  {"play", "$@$W$l$$(B", "", ""},
  {"pro", "$@$W$m(B", "", ""},
  {"py", NULL, "$@$T$#(B", ""},
  {"p", "$@$T!<(B", "$@$W(B", "$@$T!<(B"},
  {"q", "$@$-$e!<(B", "", ""},
  {"ry", NULL, "$@$j$#(B", ""},
  {"r", "$@$"!<$k(B", "$@$!(B", ""},
  {"s'", NULL, "$@$:(B", ""},
  {"sh", "$@$7$e(B", "", ""},
  {"sy", "$@$7(B", "$@$7$#(B", ""},
  {"st", NULL, "$@$9$H(B", ""},
  {"ss", "$@$($9$($9(B", "$@$9(B", ""},
  {"s", "$@$9(B", "$@$9(B", ""},
  {"there", "$@$<$"(B", NULL, NULL},
  {"these", "$@$8!<$:(B", NULL, NULL},
  {"those", "$@$>!<$:(B", NULL, NULL},
  {"they", "$@$<$$(B", NULL, NULL},
  {"them", "$@$<$`(B", NULL, NULL},
  {"then", "$@$<$s(B", NULL, NULL},
  {"thei", "$@$<(B", NULL, NULL},
  {"the", "$@$6(B", "$@$6(B", NULL},
  {"tch", NULL, "$@$C$A(B", ""},
  {"thank", "$@$5$s$/(B", NULL, NULL},
  {"that", "$@$6$C$H(B", NULL, NULL},
  {"than", "$@$6$s(B", NULL, NULL},
  {"tha", "$@$F$c(B", "", ""},
  {"this", "$@$G$#$9(B", NULL, NULL},
  {"thi", "$@$F$#(B", "", ""},
  {"thu", "$@$F$e(B", "", ""},
  {"thout", NULL, "$@$:$"$&$H(B", ""},
  {"tho", "$@$F$g(B", "", ""},
  {"two", "$@$D$%(B", "", ""},
  {"th", "$@$9(B", "$@$:(B", ""},
  {"true", "$@$H$%$k$%(B", "$@$A$c!<(B", ""},
  {"t's", NULL, "$@$C$D(B", ""},
  {"tr", "$@$H$i(B", "", ""},
  {"t", "$@$H(B", "$@$H(B", ""},
  {"v", "$@%t%#(B", "$@%t(B", ""},
  {"which", "$@$&$$$C$A(B", NULL, NULL},
  {"while", "$@$o$#$k(B", NULL, NULL},
  {"where", "$@$&$'$"(B", NULL, NULL},
  {"what", "$@$o$C$H(B", NULL, NULL},
  {"wha", "$@$o(B", NULL, NULL},
  {"who", "$@$U$%(B", NULL, NULL},
  {"wh", "$@$o(B", "", ""},
  {"ws", NULL, "$@$&$:(B", ""},
  {"w", "$@$@$V$j$e(B", "$@$%(B", ""},
  {"x", "$@$($C$/$9(B", "$@$C$/$9(B", "$@$($C$/$9(B"},
  {"y", "$@$o$$(B", "$@$#(B", ""},
  {"z", "$@$:$#(B", "$@$:(B", ""},
  {"~",  NULL, "$@!A(B", ""},       /* 0x7e */
  {NULL, NULL, NULL, NULL}
};


static int convmode;
static int convstat;    /* 0: no conv  1: normal conv  2: special conv */
#define NO_CONV        0
#define TO_KATAKANA    1
#define TO_HIRAGANA    2
static int kanamode = NO_CONV;

char *kanacpy(dst, src, max)
char *dst;
char *src;
int max;
{
  if(kanamode != NO_CONV)
  {
    int i;
    for(i = 0; src[i] != '\0' && i < max;)
    {
      if(sjis1st(src[i]))
      {
        unsigned char c1, c2;
        c1 = src[i];
        c2 = src[i + 1];
        if(kanamode == TO_KATAKANA)
        {
          if(c1 == 0x82 &&  c2 >= 0x9f && c2 <= 0xf1)
          {
            c1 ++;
            c2 += 0xa1;
            if(c2 >= 0x7f)
              c2 ++;
          }
        }
        else /* TO_HIRAGANA */
        {
          if(c1 == 0x83 &&  c2 >= 0x40 && c2 <= 0x93)
          {
            if(c2 >= 0x7f)
              c2 --;
            c1 --;
            c2 -= 0xa1;
          }
        }
        dst[i] = c1;
        i++;
        dst[i] = c2;
      }
      else
        dst[i] = src[i];
      i++;
    }
    dst[i] = '\0';
  }
  else
  {
    strncpy(dst, src, max);
  }
  return(dst);
}

int rktest(src)
char *src;
{
  int i, ret = -1;
  if(convmode == 0) return(-1);
  for(i = 0; _rk_table[i].roma != NULL; i++)
  {
    int rlen = strlen(_rk_table[i].roma);
    if(strncmp(_rk_table[i].roma, src, rlen) == 0)
    {
      ret = i;
      break;
    }
    if(*src < *_rk_table[i].roma) break;
  }
  return(ret);
}

int rktest2(src)
char *src;
{
  int i, ret = -1;
  if(convmode == 0) return(-1);
  for(i = 0; _rk_table2[i].roma != NULL; i++)
  {
    int rlen = strlen(_rk_table2[i].roma);
    if(strncmp(_rk_table2[i].roma, src, rlen) == 0)
    {
      if(_rk_table2[i].kana[convstat] == NULL) continue;
      ret = i;
      break;
    }
    if(*src < *_rk_table2[i].roma) break;
  }
  return(ret);
}


int roma2kana(dst, src, max)
char *dst;
char *src;
int max;
{
  int i, len = 0, tlen;
  char *_roma = (char *)malloc(strlen(src)+1);
  char *roma = _roma;
  strcpy(roma, src);
  convmode = 1;
  convstat = 0;
  while(*roma != '\0')
  {
    int clen = 0;
    if(*roma == '<')
    {
      if(strncmp(roma, "</r>", 4) == 0)
      {
        roma += 4;
        convmode = 0;
        continue;
      }
      else if(strncmp(roma, "<r>", 3) == 0)
      {
        roma += 3;
        convmode = 1;
        continue;
      }
    }
    else if(*roma == '\\')
    {
      roma++;
      if(*roma != '\\')
      {
        convmode = 1 - convmode;
        kanamode = 0;
        continue;
      }
    }
    else if(sjis1st(*roma))
    {
      if(len >= max - 2) goto last;
      *dst++ = *roma++;
      *dst++ = *roma++;
      len += 2;
      convstat = 1;
      continue;
    }

    if(convmode && *roma >= 'A' && *roma <= 'Z')
    {
      char *p = roma;
      kanamode = 1;
      while((*p >= 'A' && *p <= 'Z') || (*p >= 'a' && *p <= 'z'))
      {
        if(sjis1st(*p)) p++;
        else if(*p >= 'A' && *p <= 'Z') *p |= 0x20;
        p++;
      }
    }
    else if(*roma == ' ')
    {
      kanamode = 0;
    }

    if((i = rktest(roma)) != -1)
    {
      int klen = strlen(_rk_table[i].kana);
      if(len + klen >= max) goto last;
      kanacpy(dst, _rk_table[i].kana, klen);
      dst += klen;
      roma += strlen(_rk_table[i].roma);
      clen = klen;
      convstat = 1;
    }
    else
    {
      if(rktest(roma+1) != -1)
      {
        if(*roma == 'n')
        {
          kanacpy(dst, "$@$s(B", 2);
          roma ++;
          dst += 2;
          clen = 2;
          convstat = 1;
        }
        else if(*roma == *(roma + 1))
        {
          kanacpy(dst, "$@$C(B", 2);
          roma ++;
          dst += 2;
          clen = 2;
          convstat = 1;
        }
      }
    }

    if(clen == 0)
    {
      if((i = rktest2(roma)) != -1)
      {
        int klen;
        while((*_rk_table2[i].kana[convstat] == '\0')&&convstat>0) convstat--;
        klen = strlen(_rk_table2[i].kana[convstat]);
        if(len + klen >= max) goto last;
        kanacpy(dst, _rk_table2[i].kana[convstat], klen);
        dst += klen;
        roma += strlen(_rk_table2[i].roma);
        clen = klen;
        convstat = 2;
      }
      else
      {
        if(len >= max - 1) goto last;
        *dst++ = *roma++;
        clen = 1;
        convstat = 0;
      }
    }
    len += clen;
  }
last:
  *dst = '\0';
  free(_roma);
  return(len);
}

typedef struct {
  char *kana;
  char *roma;
} KR;

static KR _kr_table[] = {
  {"$@!"(B", ","},    /* 0x8141 */
  {"$@!#(B", "."},    /* 0x8142 */
  {"$@!%(B", "."},    /* 0x8144 */
  {"$@!&(B", "."},    /* 0x8145 */
  {"$@!'(B", ":"},    /* 0x8146 */
  {"$@!((B", ";"},    /* 0x8147 */
  {"$@!)(B", "?"},    /* 0x8148 */
  {"$@!*(B", "!"},    /* 0x8149 */
  {"$@!0(B", "^"},    /* 0x814f */
  {"$@!<(B", "-"},    /* 0x815b */
  {"$@!A(B", "-"},    /* 0x8160 */
  {"$@!D(B", "..."},    /* 0x8163 */
  {"$@!J(B", "("},    /* 0x8169 */
  {"$@!K(B", ")"},    /* 0x816a */
  {"$@!N(B", "["},    /* 0x816d */
  {"$@!O(B", "]"},    /* 0x816e */
  {"$@!V(B", "'"},    /* 0x8175 */
  {"$@!W(B", "'"},    /* 0x8176 */
  {"$@!X(B", "\""},    /* 0x8177 */
  {"$@!Y(B", "\""},    /* 0x8178 */
  {"$@!\(B", "+"},    /* 0x817b */
  {"$@!](B", "-"},    /* 0x817c */
  {"$@!_(B", "X"},    /* 0x817e */
  {"$@!`(B", "/"},    /* 0x8180 */
  {"$@!a(B", "="},    /* 0x8181 */
  {"$@!c(B", "<"},    /* 0x8183 */
  {"$@!d(B", ">"},    /* 0x8184 */
  {"$@!o(B", "\\"},    /* 0x818f */
  {"$@!p(B", "$"},    /* 0x8190 */
  {"$@!s(B", "%"},    /* 0x8193 */
  {"$@!t(B", "#"},    /* 0x8194 */
  {"$@!u(B", "&"},    /* 0x8195 */
  {"$@!v(B", "*"},    /* 0x8196 */
  {"$@!w(B", "@"},    /* 0x8197 */
  {"$@!{(B", "O"},    /* 0x819b */
  {"$@"*(B", "->"},    /* 0x81a8 */
  {"$@"+(B", "<-"},    /* 0x81a9 */
  {"$@$!(B", "a"},
  {"$@$"(B", "a"},
  {"$@$#(B", "i"},
  {"$@$$(B", "i"},
  {"$@$%(B", "u"},
  {"$@$&(B", "u"},
  {"$@$'(B", "e"},
  {"$@$((B", "e"},
  {"$@$)(B", "o"},
  {"$@$*(B", "o"},
  {"$@$+(B", "ka"},
  {"$@$,(B", "ga"},
  {"$@$-$c(B", "kya"},
  {"$@$-$e(B", "kyu"},
  {"$@$-$g(B", "kyo"},
  {"$@$-(B", "ki"},
  {"$@$.$c(B", "gya"},
  {"$@$.$e(B", "gyu"},
  {"$@$.$g(B", "gyo"},
  {"$@$.(B", "gi"},
  {"$@$/(B", "ku"},
  {"$@$0(B", "gu"},
  {"$@$1(B", "ke"},
  {"$@$2(B", "ge"},
  {"$@$3(B", "ko"},
  {"$@$4(B", "go"},
  {"$@$5(B", "sa"},
  {"$@$6(B", "za"},
  {"$@$7(B", "si"},
  {"$@$8$c(B", "ja"},
  {"$@$8$e(B", "ju"},
  {"$@$8$g(B", "jo"},
  {"$@$8(B", "zi"},
  {"$@$9(B", "su"},
  {"$@$:(B", "zu"},
  {"$@$;(B", "se"},
  {"$@$<(B", "ze"},
  {"$@$=$U8&(B", "SOFKEN"},
  {"$@$=$U$A$c$C$H(B", "SofChat"},
  {"$@$=(B", "so"},
  {"$@$>(B", "zo"},
  {"$@$?(B", "ta"},
  {"$@$@(B", "da"},
  {"$@$A$c(B", "cya"},
  {"$@$A$e(B", "cyu"},
  {"$@$A$g(B", "cyo"},
  {"$@$A(B", "ti"},
  {"$@$B(B", "di"},
  {"$@$C(B", ""},
  {"$@$D(B", "tu"},
  {"$@$E(B", "du"},
  {"$@$F$c(B", "tya"},
  {"$@$F$e(B", "tyu"},
  {"$@$F$g(B", "tyo"},
  {"$@$F(B", "te"},
  {"$@$G$c(B", "de"},
  {"$@$G$#(B", "di"},
  {"$@$G$e(B", "dyu"},
  {"$@$G$g(B", "dyo"},
  {"$@$G(B", "de"},
  {"$@$H(B", "to"},
  {"$@$I(B", "do"},
  {"$@$J(B", "na"},
  {"$@$K$c(B", "nya"},
  {"$@$K$e(B", "nyu"},
  {"$@$K$g(B", "nyo"},
  {"$@$K(B", "ni"},
  {"$@$L(B", "nu"},
  {"$@$M(B", "ne"},
  {"$@$N(B", "no"},
  {"$@$O(B", "ha"},
  {"$@$P(B", "ba"},
  {"$@$Q(B", "pa"},
  {"$@$R$c(B", "hya"},
  {"$@$R$e(B", "hyu"},
  {"$@$R$g(B", "hyo"},
  {"$@$R(B", "hi"},
  {"$@$S$c(B", "bya"},
  {"$@$S$e(B", "byu"},
  {"$@$S$g(B", "byo"},
  {"$@$S(B", "bi"},
  {"$@$T$c(B", "pya"},
  {"$@$T$e(B", "pyu"},
  {"$@$T$g(B", "pyo"},
  {"$@$T(B", "pi"},
  {"$@$U$!(B", "fa"},
  {"$@$U$#(B", "fi"},
  {"$@$U$'(B", "fe"},
  {"$@$U$)(B", "fo"},
  {"$@$U(B", "fu"},
  {"$@$V$!(B", "ba"},
  {"$@$V$#(B", "bi"},
  {"$@$V$'(B", "be"},
  {"$@$V$)(B", "bo"},
  {"$@$V(B", "bu"},
  {"$@$W(B", "pu"},
  {"$@$X(B", "he"},
  {"$@$Y(B", "be"},
  {"$@$Z(B", "pe"},
  {"$@$[(B", "ho"},
  {"$@$\(B", "bo"},
  {"$@$](B", "po"},
  {"$@$^(B", "ma"},
  {"$@$_$c(B", "mya"},
  {"$@$_$e(B", "myu"},
  {"$@$_$g(B", "myo"},
  {"$@$_(B", "mi"},
  {"$@$`(B", "mu"},
  {"$@$a(B", "me"},
  {"$@$b(B", "mo"},
  {"$@$c(B", "ya"},
  {"$@$d(B", "ya"},
  {"$@$e(B", "yu"},
  {"$@$f(B", "yu"},
  {"$@$g(B", "yo"},
  {"$@$h(B", "yo"},
  {"$@$i(B", "ra"},
  {"$@$j(B", "ri"},
  {"$@$k(B", "ru"},
  {"$@$l(B", "re"},
  {"$@$m(B", "ro"},
  {"$@$n(B", "wa"},
  {"$@$o(B", "wa"},
  {"$@$p(B", "wi"},
  {"$@$q(B", "we"},
  {"$@$r(B", "wo"},
  {"$@$s(B", "n"},
  {"$@%t(B", "v"},
  {NULL, NULL},
};

int krtest(src)
char *src;
{
  int i, ret = -1;
  for(i = 0; _kr_table[i].kana != NULL; i++)
  {
    int klen = (int)strlen(_kr_table[i].kana);
    if(strncmp(_kr_table[i].kana, src, klen) == 0)
    {
      ret = i;
      break;
    }
    if(strncmp(_kr_table[i].kana, src, 2) > 0) break;
  }
  return(ret);
}

int kana2roma(dst, src, max)
char *dst;
char *src;
int max;
{
  int i, len = 0;
  char *_kana = (char *)malloc(strlen(src)+1);
  char *kana = _kana;
  kanamode = TO_HIRAGANA;
  kanacpy(kana, src, strlen(src));
  while(*kana != '\0')
  {
    if(sjis1st(*kana))
    {
      unsigned char c1, c2;
      c1 = *kana;
      c2 = *(kana + 1);
      if(c1 == 0x82 && c2 >= 0x4f && c2 <= 0x58) /* 0-9 */
      {
        if(len >= max - 1) goto last;
        *dst++ = c2 - 0x1f;
        kana += 2;
        len ++;
      }
      else if(c1 == 0x82 && c2 >= 0x60 && c2 <= 0x79) /* A-Z */
      {
        if(len >= max - 1) goto last;
        *dst++ = c2 - 0x1f;
        kana += 2;
        len ++;
      }
      else if(c1 == 0x82 && c2 >= 0x81  && c2 <= 0x9a) /* a-z */
      {
        if(len >= max - 1) goto last;
        *dst++ = c2 - 0x20;
        kana += 2;
        len ++;
      }
      else if((i = krtest(kana)) != -1)
      {
        int rlen = (int)strlen(_kr_table[i].roma);
        int klen = (int)strlen(_kr_table[i].kana);
        if(rlen == 0) /* xtu */
        {
          int j;
          if((j = krtest(kana+2)) != -1)
          {
            char c = *_kr_table[j].roma;
            if(len + 1 >= max) goto last;
            if(c >= 'a' && c <= 'z')
            {
              *dst++ = c;
              len ++;
            }
            kana += 2;
            continue;
          }
        }
        if(len + klen >= max) goto last;
        strncpy(dst, _kr_table[i].roma, rlen);
        dst += rlen;
        kana += klen;
        len += rlen;
      }
      else
      {
        if(len >= max - 2) goto last;
        strncpy(dst, kana, 2);
        dst += 2;
        kana += 2;
        len += 2;
      }
    }
    else
    {
      if(len >= max - 1) goto last;
      *dst++ = *kana++;
      len++;
    }
  }
last:
  *dst = '\0';
  free(_kana);
  return(len);
}

