/* SofChat (Web Chat program SHM version)      */
/* Copyright(c) 1996-1997 Y.YONEYAMA           */
/*                                             */
/* sofchat.h                                   */

#ifndef _SOFCHAT_H_
#define _SOFCHAT_H_

#include <sys/types.h>

#define NAME_LEN       21
#define PASS_LEN       11
#define ADDR_LEN       81
#define HADDR_LEN      41
#define LABEL_LEN      81
#define AGENT_LEN     128
#define COLOR_LEN      21
#define MEMO_SIZE     256
#define MSG_SIZE     1024

typedef unsigned long IP;

typedef enum {
  m_init,
  m_entry,
  m_input,
  m_chattext,
  m_bbs,
  m_reset,
  m_logout,
  m_customize,
  m_debug,
  m_doc
} CHATMODE;

/* flags */
#define USER_ITALIC       (1)

typedef struct {
  char name[NAME_LEN];          /* Handle name */
  char password[PASS_LEN];      /* password */
  char address[ADDR_LEN];       /* mail address or http URL */
  char referer[ADDR_LEN];       /* HTTP_REFERER */
  char haddress[HADDR_LEN];     /* host address */
  char agent[AGENT_LEN];        /* name of browser */
  char memo[MEMO_SIZE];         /* messages */
  char namecolor[COLOR_LEN];    /* name color */
  char textcolor[COLOR_LEN];    /* text color */
  IP   haddressip;              /* host address (IP) */
  time_t logintime;             /* last login time */
  time_t atime;                 /* last atach time */
  time_t ctime;                 /* chat time */
  time_t btime;                 /* bbs last access time */
  int  login;                   /* login status */
  int  count;                   /* speech count */
  int  permit;                  /* permission */
  int  refresh;                 /* refresh time */
  int  maxlines;                /* max log lines */
  int  room;                    /* chat room */
  int  flags;                   /* other flags */
  int  mid;                     /* modified id */
} USERINFO;

#define F_AUTOCLEAR      1

typedef struct {
  time_t atime;
  IP     address;
  char   name[NAME_LEN];        /* Handle name */
  int  mid;                     /* modified id */
} HOSTINFO;


/* flags */
#define TEXT_ITALIC       (1)

#define SECURE_BBS        (1)

typedef struct {
  time_t atime;                 /* access time */
  char namecolor[COLOR_LEN];    /* name color */
  char textcolor[COLOR_LEN];    /* text color */
  char name[NAME_LEN];          /* Handle name */
  char message[MSG_SIZE];       /* message */
  int  room;                    /* room no */
  int  flags;                   /* other flags */
} TEXT;

typedef struct {
  char label_ja[LABEL_LEN];
  char label_en[LABEL_LEN];
  char url[ADDR_LEN];
} LINK;

#endif /* _SOFCHAT_H_ */
